SystemOrganization addCategory: #ConfigurationOfSimpleApplescript!

Object subclass: #ConfigurationOfSimpleApplescript
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSimpleApplescript'!

!ConfigurationOfSimpleApplescript class methodsFor: 'development support' stamp: 'SeanDeNigris 12/6/2011 10:27'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSimpleApplescript class methodsFor: 'private' stamp: 'SeanDeNigris 12/6/2011 10:27'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSimpleApplescript class methodsFor: 'private' stamp: 'SeanDeNigris 12/6/2011 10:27'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSimpleApplescript class methodsFor: 'private' stamp: 'SeanDeNigris 12/6/2011 10:27'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSimpleApplescript class methodsFor: 'metacello tool support' stamp: 'SeanDeNigris 12/6/2011 10:27'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSimpleApplescript class methodsFor: 'loading' stamp: 'SeanDeNigris 12/6/2011 10:27'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSimpleApplescript class methodsFor: 'loading' stamp: 'SeanDeNigris 12/6/2011 10:27'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSimpleApplescript class methodsFor: 'loading' stamp: 'SeanDeNigris 12/6/2011 10:27'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSimpleApplescript class methodsFor: 'accessing' stamp: 'SeanDeNigris 12/6/2011 10:27'!
project

	^self new project! !

!ConfigurationOfSimpleApplescript class methodsFor: 'development support' stamp: 'SeanDeNigris 12/6/2011 10:27'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSimpleApplescript methodsFor: 'baselines' stamp: 'SeanDeNigris 12/6/2011 10:40'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://squeaksource.com/SPDPlayground'.
		spec project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'CommandShell-Piping' with: [
				spec
					repository: 'http://www.squeaksource.com/CommandShell';
					requires: #('OSProcess' ). ];
			package: 'SimpleApplescript' with: [
				spec requires: #('CommandShell-Piping' ) ].
		spec group: 'default' with: #('SimpleApplescript' ). ].
! !

!ConfigurationOfSimpleApplescript methodsFor: 'baselines' stamp: 'SeanDeNigris 8/6/2012 16:29'!
baseline20: spec
	<version: '2.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://squeaksource.com/SPDPlayground'.
		spec description: '- split Applescript package into -Core and -Specification'.
		spec project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'CommandShell-Piping' with: [
				spec
					repository: 'http://www.squeaksource.com/CommandShell';
					requires: #('OSProcess' ). ];
			package: 'SimpleApplescript-Core' with: [
				spec requires: #('CommandShell-Piping' ) ];
			package: 'SimpleApplescript-Specification' with: [
				spec requires: #(SimpleApplescript-Core) ].
		spec group: 'Core' with: #('SimpleApplescript-Core' ). ].
! !

!ConfigurationOfSimpleApplescript methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 8/6/2012 16:29'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '2.0'.
! !

!ConfigurationOfSimpleApplescript methodsFor: 'accessing' stamp: 'SeanDeNigris 12/6/2011 10:27'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSimpleApplescript methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 12/6/2011 10:52'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfSimpleApplescript methodsFor: 'versions' stamp: 'SeanDeNigris 12/6/2011 10:52'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'initial development version'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '12/6/2011 10:38'.
		spec project: 'OSProcess' with: #'stable'.
		spec 
			package: 'CommandShell-Piping' with: 'CommandShell-Piping-dtl.10';
			package: 'SimpleApplescript' with: 'SimpleApplescript-SeanDeNigris.1'. ].
! !

!ConfigurationOfSimpleApplescript methodsFor: 'versions' stamp: 'SeanDeNigris 8/6/2012 16:26'!
version20: spec
	<version: '2.0' imports: #('2.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '
- pull osascript behavior into a wrapper class, soon to be moved to its own library
- convert output into Smalltalk objects e.g. ''true'' -> true'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '8/6/2012 16:25'.
		spec project: 'OSProcess' with: #'stable'.
		spec 
			package: 'CommandShell-Piping' with: 'CommandShell-Piping-dtl.10'
			"load latest versions of Core and Specification until release". ].
! !
